config/routes.rb
Rails.application.routes.draw do

  # use_doorkeeper
  scope 'api' do
    use_doorkeeper do
      skip_controllers :authorizations, :applications, :authorized_applications
    end
  end

  mount Rswag::Ui::Engine => '/api-docs'
  mount Rswag::Api::Engine => '/api-docs'

  mount ProwhyApi::Api => '/api'

  scope '(:locale)', locale: /#{I18n.available_locales.join("|")}/ do
    # mount ProwhyApi::Api => '/api'

    # your routes here...
    namespace :labels do
      resources :cause_types
      get 'cause_types_list', to: 'cause_types#cause_types_list'
      post 'cause_types_list_set', to: 'cause_types#cause_types_list_set'
      resources :criteria
      resources :configs
      get 'config_add_criteria', to: 'configs#add_criteria'
      patch 'config_add_criteria_valid', to: 'configs#add_criteria_valid'
      get 'config_formula_test', to: 'configs#formula_test'
      resources :values
      resources :qqoqcp_lines
      resources :qqoqcp_configs
      get 'qqoqcp_config_add_line', to: 'qqoqcp_configs#add_line'
      patch 'qqoqcp_config_add_line_valid', to: 'qqoqcp_configs#add_line_valid'
      resources :check_list_elems
    end

    # scope module: 'tools' do
    namespace :tools do
      resources :qqoqcps
      resources :causes, only: [:new, :create, :edit, :update, :destroy]
      get 'cause_edit_status', to: 'causes#edit_status'
      resources :tasks
      resources :decision_mats
      # Cause Tree
      resources :cause_trees, only: [:index]
      get 'cause_trees_js_tree_data', to: 'cause_trees#cause_trees_js_tree_data'
      # Cause Tree => 5Why
      get 'cause_trees_index_5why', to: 'cause_trees#index_5why'
      # Ishikawa
      resources :ishikawas, only: [:index]
      get 'ishikawa_js_tree_data', to: 'ishikawas#ishikawa_js_tree_data'
      post 'ishikawa_drag_cause', to: 'ishikawas#ishikawa_drag_cause'
      get 'ishikawa_reset_branchs', to: 'ishikawas#ishikawa_reset_branchs'
      get 'ishikawa_zoom', to: 'ishikawas#ishikawa_zoom'
      post 'ishikawa_update_option', to: 'ishikawas#ishikawa_update_option'
      post 'save_canvas_to_png', to: 'ishikawas#save_canvas_to_png'
      post 'save_image', to: 'ishikawas#save_image'
      # Tasks
      get 'tasks_index_js', to: 'tasks#index_js'
      get 'tasks_export_pdf', to: 'tasks#export_pdf'
      get 'task_get_cause', to: 'tasks#task_get_cause'
      patch 'task_update_advance', to: 'tasks#update_advance'
      get 'tasks_send_emails', to: 'tasks#send_emails'
      post 'tasks_index_posts', to: 'tasks#index'
      get 'tasks_index_posts', to: 'tasks#index'

      get 'tasks_check_list', to: 'tasks#check_list'
      post 'tasks_check_list_valid', to: 'tasks#check_list_valid'

      get 'tasks_reschedule', to: 'tasks#reschedule'

      # Decision Mats
      # get 'decision_mat_open', to: 'decision_mats#open'
      patch 'decision_mat_save_values', to: 'decision_mats#save_values'
      delete 'decision_mat_delete_entry', to: 'decision_mats#delete_entry'
      get 'decision_mat_add_entry', to: 'decision_mats#add_entry'
      patch 'decision_mat_valid_entries', to: 'decision_mats#valid_entries'
      get 'decision_mat_add_criteria', to: 'decision_mats#add_criteria'
      patch 'decision_mat_valid_criteria', to: 'decision_mats#valid_criteria'
      # Teams
      resources :teams
      # Documents
      resources :documents
      # RcaRport
      resources :rca_reports, only: [:index]
      get 'rca_report_export', to: 'rca_reports#rca_report_export'
      get 'rca_report_comm', to: 'rca_reports#rca_report_comm'
      get 'rca_report_add_person', to: 'rca_reports#rca_report_add_person'
      get 'rca_report_add_person_do', to: 'rca_reports#rca_report_add_person_do'
      # Criticity
      resources :criticities
      patch 'criticity_calculate', to: 'criticities#calculate'
      # Images
      resources :images
      # Indicators
      resources :indicators
      post 'indicator_save_image', to: 'indicators#save_image'
      resources :indicator_measures
      patch 'indicator_measure_up', to: 'indicator_measures#indicator_measure_up'
      patch 'indicator_measure_down', to: 'indicator_measures#indicator_measure_down'
      # Check Efficacity
      resources :check_efficacity, only: [:index]
      get 'check_efficacity_edit_efficacity', to: 'check_efficacity#edit_efficacity'
      # Efficacity
      resources :efficacities
      # Generic
      resources :generics
      get 'generics_download_last_doc', to: 'generics#download_last_doc'
      # RcaList
      resources :rca_lists
    end

    namespace :meth do
      resources :tools
      resources :activities
      resources :list_contents # , only: [:index]
      resources :custom_field_descs
      resources :custom_field_types
      resources :steps
      resources :methodologies
      resources :step_tools
      resources :tool_custom_fields
      get 'step_tool_show', to: 'step_tools#step_tool_show'
      get 'step_tool_import', to: 'step_tools#step_tool_import'
      post 'step_tool_import_do', to: 'step_tools#step_tool_import_do'
      # Fonctions step à mettre dans des services
      get 'step_import', to: 'steps#step_import'
      post 'step_import_do', to: 'steps#step_import_do'
      get 'step_copy', to: 'steps#step_copy'
      post 'step_copy_do', to: 'steps#step_copy_do'
      delete 'step_del_tool', to: 'steps#step_del_tool'
      post 'step_add_tool', to: 'steps#step_add_tool'
      patch 'step_tool_up', to: 'steps#step_tool_up'
      patch 'step_tool_down', to: 'steps#step_tool_down'
      patch 'step_up', to: 'steps#step_up'
      patch 'step_down', to: 'steps#step_down'

      get 'tool_active', to: 'tool#tool_active'

      patch 'list_content_up', to: 'list_contents#list_content_up'
      patch 'list_content_down', to: 'list_contents#list_content_down'
      get 'list_content_new_from_csv', to: 'list_contents#new_from_csv'
      post 'list_content_create_from_csv', to: 'list_contents#create_from_csv'
      get 'list_content_export_csv', to: 'list_contents#export_csv'
      get 'list_content_export_save_csv', to: 'list_contents#export_save_csv'

      delete 'custom_field_desc_delete_all_list', to: 'custom_field_descs#delete_all_list'
      get 'custom_field_desc_dependant_fields_refresh', to: 'custom_field_descs#dependant_fields_refresh'
      get 'custom_field_desc_update_list_dependencies', to: 'custom_field_descs#update_list_dependencies'

      get 'show_tool_custom_field', to: 'tool_custom_fields#show_tool'
      patch 'tool_custom_field_up', to: 'tool_custom_fields#tool_custom_field_up'
      patch 'tool_custom_field_down', to: 'tool_custom_fields#tool_custom_field_down'

      get 'methodology_edit_meth', to: 'methodologies#edit_meth'
      post 'methodology_copy', to: 'methodologies#copy'

      # Tree Cntent for Custom fields
      resources :tree_contents
      get 'tree_contents_js_tree_data', to: 'tree_contents#js_tree_data'
    end

    namespace :admin do
      resources :admin_configs, only: [:index, :edit, :update]
      delete 'admin_config_delete_customer', to: 'admin_configs#delete_customer'
      resources :ldap_configs
      get 'ldap_config_test', to: 'ldap_configs#ldap_config_test'
      resources :perimeters
      get 'perimeters_assign_users', to: 'perimeters#assign_users'
      get 'perimeters_js_tree_data', to: 'perimeters#js_tree_data'
      patch 'perimeters_assign_users_valid', to: 'perimeters#assign_users_valid'
      resources :helper_texts
    end

    resources :custom_fields
    devise_for :users, controllers: { registrations: 'users/registrations',
                                      sessions: 'users/sessions' }
    devise_scope :user do
      get 'edit_user_preferences_registration', to: 'users/registrations#edit_preferences'
      patch 'update_user_preferences_registration', to: 'users/registrations#update_preferences'
    end
    resources :users_admin, controller: 'users', only: [:index, :new, :create, :edit, :update, :destroy]
    get 'users_admin_send_test_mail', to: 'users#send_test_mail'
    get 'users_admin_ldap_search', to: 'users#ldap_search'
    post 'users_admin_ldap_search_valid', to: 'users#ldap_search_valid'
    patch 'users_admin_update_pa_options', to: 'users#update_pa_options'
    resources :rcas
    patch 'rca_advancement_set', to: 'rcas#advancement_set'
    patch 'rca_reinit_all_advancements', to: 'rcas#reinit_all_advancements'
    get 'rca_closure', to: 'rcas#rca_closure'
    # patch 'rcas_search', to: 'rcas#rcas_search'
    patch 'rcas', to: 'rcas#index'
    patch 'rcas_reinit_filters_index', to: 'rcas#reinit_filters_index'
    get 'rcas_reinit_filters', to: 'rcas#reinit_filters'
    patch 'rcas_items_pp', to: 'rcas#rcas_items_pp'
    # get 'rcas_action_plan', to: 'rcas#rcas_action_plan'
    get 'rcas_assign_perimeters', to: 'rcas#assign_perimeters'
    patch 'rcas_assign_perimeters_valid', to: 'rcas#assign_perimeters_valid'
    get 'rca_recovery', to: 'rcas#recovery'
    patch 'rca_recovery_do', to: 'rcas#recovery_do'
    get 'rca_export_ods', to: 'rcas#export_ods'
    get 'rca_add_parent', to: 'rcas#rca_add_parent'
    patch 'rca_add_parent_valid', to: 'rcas#rca_add_parent_valid'
    delete 'rca_delete_parent', to: 'rcas#rca_delete_parent'

    resources :posts
    resources :tags, only: [:index, :show, :update]
    resources :admin, only: [:index]
    get 'admin_show_ahoy', to: 'admin#show_ahoy'
    resources :people
    get 'person_choose', to: 'people#person_choose'
    get 'person_choose_valid', to: 'people#person_choose_valid'
    resources :profils
    patch 'profil_raz_authorizations', to: 'profils#raz_authorizations'
    resources :profil_authorizes, only: [:index, :create, :update]
    resources :roles, only: [:index, :create]

    get 'tagged/:tag', to: 'posts#index', as: :tagged

    get 'tags_list', to: 'tags#tags_list'
    get 'tags_js_tree_data', to: 'tags#tags_js_tree_data'

    # get 'create_route_js', to: 'rcas#create_route_js'

    # get 'causes_js_tree_data', to: 'causes#causes_js_tree_data'

app/controllers/labels/cause_types_controller.rb
module Labels
  class CauseTypesController < ApplicationController
    include AdminConcern
    # layout 'admin'
    before_action :set_labels_cause_type, only: [:edit, :update, :destroy]

    # GET /labels/cause_types
    # GET /labels/cause_types.json
    def index
      @labels_cause_types = Labels::CauseType.all
      authorize CauseType
    end

    # # GET /labels/cause_types/1
    # # GET /labels/cause_types/1.json
    # def show
    # end

    # GET /labels/cause_types/new
    def new
      @labels_cause_type = Labels::CauseType.new
      authorize @labels_cause_type
    end

    # GET /labels/cause_types/1/edit
    def edit
    end

    # POST /labels/cause_types
    # POST /labels/cause_types.json
    def create
      @labels_cause_type = Labels::CauseType.new(labels_cause_type_params)
      authorize @labels_cause_type

      respond_to do |format|
        if @labels_cause_type.save
          format.html { redirect_to labels_cause_types_url, notice: t('.message_succes', cause_type: Labels::CauseType.model_name.human) }
          format.json { render :show, status: :created, location: @labels_cause_type }
        else
          format.html { render :new }
          format.json { render json: @labels_cause_type.errors, status: :unprocessable_entity }
        end
      end
    end

    # PATCH/PUT /labels/cause_types/1
    # PATCH/PUT /labels/cause_types/1.json
    def update
      respond_to do |format|
        if @labels_cause_type.update(labels_cause_type_params)
          format.html { redirect_to labels_cause_types_url, notice: t('.message_succes', cause_type: Labels::CauseType.model_name.human) }
          format.json { render :show, status: :ok, location: @labels_cause_type }
        else
          format.html { render :edit }
          format.json { render json: @labels_cause_type.errors, status: :unprocessable_entity }
        end
      end
    end

    # DELETE /labels/cause_types/1
    # DELETE /labels/cause_types/1.json
    def destroy
      @labels_cause_type.destroy
      respond_to do |format|
        format.html { redirect_to labels_cause_types_url, notice: t('.message_succes', cause_type: Labels::CauseType.model_name.human) }
        format.json { head :no_content }
      end
    end

    # GET => open modal to set cause types to step_tool
    # TODO : déplacer le contenu dans une fonction du model step_tool (pour tests séparés model et request)
    # ici appel de la fonction : @labels = @step_tool.list_labels
    def cause_types_list
      authorize CauseType

      @step_tool = Meth::StepTool.find(params[:step_tool])
      @list_labels = []
      # if @step_tool.tool_options[:labels]
      @step_tool&.tool_options&.[](:labels)&.keys&.sort&.each do |k|
        @list_labels << @step_tool.tool_options[:labels][k]
      end
      # end

      @labels = Labels::CauseType.all
    end

    # POST => update step_tool options (cause types list for Ishikawa)
    # TODO : déplacer le contenu dans une fonction du model (ou service ?) step_tool
    # => pour tests séparés model=test résultats et request=test fonctionnement/redirections
    # ici appel de la fonction : @labels = @step_tool.list_labels_set(params[labels_ids])
    def cause_types_list_set
      authorize CauseType

      @step_tool = Meth::StepTool.find(params[:step_tool])
      @step_tool.tool_options ||= {}
      @step_tool.tool_options[:labels] = {}
      pos = 1
      params&.[]('labels_ids')&.each do |label_id|
        @step_tool.tool_options[:labels][pos] = label_id.to_i
        pos += 1
      end
      @step_tool.save!

      redirect_to edit_meth_methodology_path(@step_tool.step.methodology, step: @step_tool.step)
    end

    private

    # Use callbacks to share common setup or constraints between actions.
    def set_labels_cause_type
      @labels_cause_type = Labels::CauseType.find(params[:id])
      authorize @labels_cause_type
    end

    # Only allow a list of trusted parameters through.
    def labels_cause_type_params
      params.require(:labels_cause_type).permit(:name, :name_fr, :name_en, :pos)
    end
  end
end

app/controllers/labels/check_list_elems_controller.rb
module Labels
  class CheckListElemsController < ApplicationController
    include AdminConcern
    before_action :set_labels_check_list_elem, only: %i[show edit update destroy]

    # GET /labels/check_list_elems or /labels/check_list_elems.json
    def index
      authorize CheckListElem
      @labels_check_list_elems = Labels::CheckListElem.all
    end

    # # GET /labels/check_list_elems/1 or /labels/check_list_elems/1.json
    # def show
    # end

    # GET /labels/check_list_elems/new
    def new
      @labels_check_list_elem = Labels::CheckListElem.new
      authorize @labels_check_list_elem
    end

    # GET /labels/check_list_elems/1/edit
    def edit
    end

    # POST /labels/check_list_elems or /labels/check_list_elems.json
    def create
      @labels_check_list_elem = Labels::CheckListElem.new(labels_check_list_elem_params)
      authorize @labels_check_list_elem

      respond_to do |format|
        if @labels_check_list_elem.save
          format.html { redirect_to labels_check_list_elems_url, notice: 'Check list elem was successfully created.' }
          # { redirect_to labels_check_list_elem_url(@labels_check_list_elem), notice: 'Check list elem was successfully created.' }
          format.json { render :show, status: :created, location: @labels_check_list_elem }
        else
          format.html { render :new, status: :unprocessable_entity }
          format.json { render json: @labels_check_list_elem.errors, status: :unprocessable_entity }
        end
      end
    end

    # PATCH/PUT /labels/check_list_elems/1 or /labels/check_list_elems/1.json
    def update
      respond_to do |format|
        if @labels_check_list_elem.update(labels_check_list_elem_params)
          format.html { redirect_to labels_check_list_elems_url, notice: 'Check list elem was successfully updated.' }
          format.json { render :show, status: :ok, location: @labels_check_list_elem }
        else
          format.html { render :edit, status: :unprocessable_entity }
          format.json { render json: @labels_check_list_elem.errors, status: :unprocessable_entity }
        end
      end
    end

    # DELETE /labels/check_list_elems/1 or /labels/check_list_elems/1.json
    def destroy
      @labels_check_list_elem.destroy

      respond_to do |format|
        format.html { redirect_to labels_check_list_elems_url, notice: 'Check list elem was successfully destroyed.' }
        format.json { head :no_content }
      end
    end

    private

    # Use callbacks to share common setup or constraints between actions.
    def set_labels_check_list_elem
      @labels_check_list_elem = Labels::CheckListElem.find(params[:id])
      authorize @labels_check_list_elem
    end

    # Only allow a list of trusted parameters through.
    def labels_check_list_elem_params
      params.require(:labels_check_list_elem).permit(:name, :task_detail_type, :usable)
    end
  end
end

app/helpers/labels/cause_types_helper.rb
module Labels
  module CauseTypesHelper
  end
end

app/helpers/labels/check_list_elems_helper.rb
module Labels
  module CheckListElemsHelper
    def elem_tasks_nb(elem, rca)
      nb = elem.tools_tasks.where(rca: rca).size
      nb == 0 ? fa_icon_xmark : "<span class='icon-status-validated' style='border:1px solid #05ae05; padding: 0 7px; border-radius: 0.25rem;'>#{nb}</span>".html_safe
    end
  end
end

app/helpers/labels/configs_helper.rb
module Labels
  module ConfigsHelper
  end
end

app/helpers/labels/criteria_helper.rb
module Labels
  module CriteriaHelper
  end
end

app/helpers/labels/qqoqcp_configs_helper.rb
module Labels
  module QqoqcpConfigsHelper
  end
end

app/views/labels/cause_types/_cause_types_list_modal.html.erb
<style>
  .label_icon {
    cursor: pointer;
  }
  #labels_used div {
    border: 1px solid #777;
    border-radius: 2px;
    padding-left: 2px;
    cursor: pointer;
  }
</style>

<div class="modal-header">
  <h5 class="modal-title" id="exampleModalLabel"><%= @modal_title.nil? ? t('modal_ishi_title') : @modal_title %></h5>
  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
    <span aria-hidden="true">&times;</span>
  </button>
</div>

<div class="modal-body">

  <div class="row">
    <div class="col-md-6 admin-col">
      <div class="admin-col-title"><%= t('modal_ishi_lbl_use') %></div>
      <%= form_with url: labels_cause_types_list_set_path do |form| %>
        <%= hidden_field_tag 'step_tool', @step_tool.id %>
        <div id='labels_used' class="admin-col-content">
          <% @list_labels.each do |label_id| %>
            <% label = Labels::CauseType.find(label_id) %>
            <div id='<%= label.id %>'> <!-- class='label_change_used label_used'> -->
              <span class='label_icon label_change_used label_used'><%= fa_icon('minus-square') %></span>
              <%= hidden_field_tag "labels_ids[]", label.id %>
              <%= label.name %>
            </div>
          <% end %>
        </div>
        <br>
        <%= form.submit t('modal_ishi_valid') %>
      <% end %>
    </div>
    <div class="col-md-6 admin-col">
      <div class="admin-col-title"><%= t('modal_ishi_lbl_un_use') %></div>
      <div id='labels_unused' class="admin-col-content">
        <% @labels.each do |label| %>
          <% unless @list_labels.include?(label.id) %>
            <div id='<%= label.id %>'> <!-- class='label_change_used label_unused'> -->
              <span class='label_icon label_change_used label_unused'><%= fa_icon('plus-square') %></span>
              <%= hidden_field_tag "labels_ids[]", label.id %>
              <%= label.name %>
            </div>
          <% end %>
        <% end %>
      </div>
    </div>
  </div>
</div>

<!-- <div class="modal-footer">
</div> -->

<script text="javascript">
  $(function() {
    $(".label_change_used").click(function(event) {
      console.log("Del label");
      console.log(this.value);

      if($(this).hasClass('label_unused')) {
        console.log("Add label");
        $(this).removeClass('label_unused').addClass('label_used');
        $(this).parent().detach().appendTo('#labels_used');
        // $(this).find('.label_icon').html('<%= fa_icon("minus-square") %>');
        $(this).html('<%= fa_icon("minus-square") %>');
      }
      else {
        console.log("Del label");
        $(this).removeClass('label_used').addClass('label_unused');
        $(this).parent().detach().appendTo('#labels_unused');
        // $(this).find('.label_icon').html('<%= fa_icon("plus-square") %>');
        $(this).html('<%= fa_icon("plus-square") %>');
      }
    });

    $("#labels_used").sortable();
  });
</script>

app/views/labels/cause_types/_form.html.erb
<%= simple_form_for(@labels_cause_type) do |f| %>
  <%= f.error_notification %>
  <%= f.error_notification message: f.object.errors[:base].to_sentence if f.object.errors[:base].present? %>

  <div class="form-inputs">
    <% Labels::CauseType.locale_columns(:name).each do |column| %>
      <%= f.input column %>
    <% end %>
    <%= f.input :pos %>
  </div>

  <div class="form-actions">
    <%= f.button :submit, class: 'btn btn-outline-warning' %>
  </div>
<% end %>

app/views/labels/cause_types/cause_types_list.js.erb
$("#modal-window").find(".modal-content").html("<%= j (render 'cause_types_list_modal') %>");
$("#modal-window").modal();

app/views/labels/cause_types/edit.html.erb
<h4><%= t('.title', cause_type: Labels::CauseType.model_name.human) %></h4>

<%= render 'form', labels_cause_type: @labels_cause_type %>

<br/><%= link_to t('back'), labels_cause_types_path %>

app/views/labels/cause_types/index.html.erb
<h4><%= t('.title', cause_type: Labels::CauseType.model_name.human(count: 2)) %></h4>

<table data-tablesort='true' data-toggle="tablesort" class="tablesorter">
  <thead>
    <tr>
      <% Labels::CauseType.locale_columns(:name).each do |column| %>
        <th><%= Labels::CauseType.human_attribute_name column %></th>
      <% end %>
      <th colspan="2"></th>
    </tr>
  </thead>

  <tbody>
    <% @labels_cause_types.each do |labels_cause_type| %>
      <tr>
        <% Labels::CauseType.locale_columns(:name).each do |column| %>
          <td><%= labels_cause_type.send(column) %></td>
        <% end %>
        <td><%= link_to fa_icon_edit, edit_labels_cause_type_path(labels_cause_type) %></td>
        <td><%= link_to fa_icon_delete, labels_cause_type, method: :delete, data: { confirm: t('confirm.sure') } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to t('.new', cause_type: Labels::CauseType.model_name.human), new_labels_cause_type_path, class: 'btn btn-outline-warning' %>

app/views/labels/cause_types/new.html.erb
<h4><%= t('.title', cause_type: Labels::CauseType.model_name.human) %></h4>

<%= render 'form', labels_cause_type: @labels_cause_type %>

<br/><%= link_to t('back'), labels_cause_types_path %>

app/views/labels/cause_types/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Name:</strong>
  <%= @labels_cause_type.name %>
</p>

<p>
  <strong>Pos:</strong>
  <%= @labels_cause_type.pos %>
</p>

<%= link_to 'Edit', edit_labels_cause_type_path(@labels_cause_type) %> |
<%= link_to t('back'), labels_cause_types_path %>